import { Button } from '@kobalte/core';
import { A } from '@solidjs/router';
import PouchDb from 'pouchdb';
import { Component, createEffect, For } from 'solid-js';
import { createServerAction$ } from 'solid-start/server';
import { useNavigate } from 'solid-start';

interface Props {}

const Users: Component<Props> = (props) => {
  const navigate = useNavigate();

  const [users, getUsers] = createServerAction$(
    async (values: any) => {
      const db = new PouchDb('.db');
      const results = await db.allDocs({
        include_docs: true,
        startkey: 'user/',
        endkey: 'user/\ufff0',
      });
      console.log({ caller: 'Users / serverAction', results });
      return results.rows;
    }
  );

  getUsers();

  createEffect(() => {
    console.log({
      caller: 'Users',
      users: users.result,
    });
  });

  const newHandler = () => {
    navigate('/user/new');
  };

  return (
    <>
      <Button.Root onclick={newHandler}>New</Button.Root>
      <ul>
        <For each={users.result}>
          {(user: any) => {
            console.log({
              caller: 'Users / loop',
              users: user,
            });
            return (
              <li>
                <A href={encodeURIComponent(user.id)}>
                  {user.doc.mail}
                </A>
              </li>
            );
          }}
        </For>
      </ul>
    </>
  );
};

export default Users;
